{$A-,I-,R-,Q-,X+

                                                                         
  X2COM version 0.03                                                     
                                                                         
  EXE to COM or BIN convertor for YaOS core file. Works good with the    
  standard MS-DOS EXE-files. Supports four slightly different methods.   
  Compile with Borland Pascal version 5.5 to 7.1, Borland Delphi (any    
  version) or TMT Pascal Lite version 2.0.                               
                                                                         
  Y [27-07-99]..[05-08-99]                                               
                                                                         
  Modified:                                                              
  27-07-99 by Y: initial implementation (0.00 alpha)                     
  31-07-99 by Y: ported to Delphi32 for DOS (0.01 alpha)                 
  02-08-99 by Y: added new signature - just for fun (0.01 beta)          
  04-08-99 by Y: added alternative conversion method (0.02 alpha)        
  05-08-99 by Y: startup registers are set more carefully. Alternative   
    conversion method is now used by default (0.02 beta)                 
  05-08-99 by Y: added command line parsing and two new loaders with     
    memory block resizing code (0.03 alpha)                              
  05-08-99 by Y: removed some lame stuff from standard loaders (0.03b)   
  09-08-99 by Y: ported to TMT Pascal v.2.0 (0.03)                       
                                                                         

}
program         x2com;
{$IfDef Win32}
uses            Windows;        {GetCommandLine Win API function used}
  {$M 16384, 65536} {$D+,E+,I-,L+,N+,S+,V-}
  {$H-} {don't use long strings by default}
  {$IfNDef Ver80}
     {$AppType Console}         // Delphi32 v.8.0 does not support AppType
  {$Endif  Ver80}
{$Else Win32}
  {$IfNDef __TMT__}
    {$M 16384, 65536, 655360} {$D+,E+,G+,I-,L+,N+,S+,V-}
  {$Else   __TMT__}
uses            Use32, Arg;     -- TMT Pascal: 32bit types and command line
  {$Endif  __TMT__}
{$EndIf Win32}

const           Version = '0.03';
                Date = '09-08-99';

                FirstPart:
                packed record
                  bJMP: System.Byte;
                  wOffset: System.Word;
                  aOther: array [0..12] of System.Char;
                end =
                ( bJMP: $E9;
                  wOffset: 0;
                  aOther: 'x2com v.0.03f'
                );

                {standard method, no DOS calls at all}
                ThirdPart: array [0..113] of byte = ( {x2comld1.asm}
                $E8,$00,$00,$5E,$81,$EE,$00,$01,$8B,$DE,$8C,$C8,$8E,$D8,$8E,
                $C0,$05,$10,$00,$BE,$6F,$01,$8B,$50,$04,$03,$D0,$89,$50,$04,
                $8B,$50,$02,$03,$D0,$89,$50,$02,$8B,$48,$08,$E3,$10,$BE,$79,
                $01,$BF,$10,$01,$03,$38,$83,$C6,$02,$01,$05,$49,$75,$F6,$FC,
                $8E,$C0,$8E,$D8,$33,$FF,$BE,$10,$00,$8B,$CB,$2B,$CF,$D1,$E9,
                $F3,$A5,$8C,$C8,$8E,$D8,$8E,$C0,$BE,$6F,$01,$FA,$8E,$50,$04,
                $8B,$60,$06,$FB,$8C,$DA,$8B,$30,$33,$C0,$B9,$02,$72,$51,$9D,
                $B9,$FF,$00,$8B,$D8,$50,$8B,$FC,$EA);

                {alternative method (exe file kept intact), no DOS calls}
                ThirdPartAlt: array [0..151] of byte = ( {x2comld2.asm}
                $E8,$00,$00,$5E,$81,$EE,$00,$01,$8B,$DE,$8C,$C8,$8E,$D8,$8E,
                $C0,$05,$10,$00,$FF,$06,$18,$01,$BE,$95,$01,$8B,$16,$1E,$01,
                $03,$D0,$89,$50,$04,$8B,$16,$20,$01,$89,$50,$06,$8B,$16,$26,
                $01,$03,$D0,$89,$50,$02,$8B,$16,$24,$01,$89,$10,$8B,$0E,$16,
                $01,$E3,$1C,$8B,$3E,$28,$01,$26,$C5,$B5,$10,$01,$83,$C7,$04,
                $8C,$DA,$03,$D0,$2E,$03,$16,$18,$01,$8E,$DA,$01,$04,$49,$75,
                $E8,$FC,$8E,$C0,$8E,$D8,$33,$FF,$2E,$8B,$36,$18,$01,$B1,$04,
                $D3,$E6,$8B,$CB,$2B,$CE,$D1,$E9,$F3,$A5,$8C,$C8,$8E,$D8,$8E,
                $C0,$BE,$95,$01,$FA,$8E,$50,$04,$8B,$60,$06,$FB,$8C,$DA,$8B,
                $30,$33,$C0,$B9,$02,$72,$51,$9D,$B9,$FF,$00,$8B,$D8,$50,$8B,
                $FC,$EA);

                {standard method with memory block resizing code}
                ThirdPartM: array [0..193] of byte = ( {x2comld3.asm}
                $E8,$00,$00,$5E,$81,$EE,$00,$01,$8B,$DE,$8C,$C8,$8E,$D8,$8E,
                $C0,$05,$10,$00,$BE,$BF,$01,$8B,$50,$04,$03,$D0,$89,$50,$04,
                $8B,$50,$02,$03,$D0,$89,$50,$02,$8B,$48,$08,$E3,$10,$BE,$CD,
                $01,$BF,$10,$01,$03,$38,$83,$C6,$02,$01,$05,$49,$75,$F6,$FC,
                $8E,$C0,$8E,$D8,$33,$FF,$BE,$10,$00,$8B,$CB,$2B,$CF,$D1,$E9,
                $F3,$A5,$8C,$C8,$8E,$D8,$8E,$C0,$53,$BE,$BF,$01,$8B,$58,$0C,
                $B4,$4A,$CD,$21,$73,$42,$8B,$D3,$5B,$53,$3B,$50,$0A,$72,$08,
                $8B,$DA,$B4,$4A,$CD,$21,$73,$31,$5B,$8B,$D3,$81,$C2,$7D,$01,
                $B4,$09,$CD,$21,$B4,$4C,$CD,$21,$50,$72,$6F,$67,$72,$61,$6D,
                $20,$74,$6F,$6F,$20,$62,$69,$67,$20,$74,$6F,$20,$66,$69,$74,
                $20,$69,$6E,$20,$6D,$65,$6D,$6F,$72,$79,$2E,$24,$5B,$BE,$BF,
                $01,$FA,$8E,$50,$04,$8B,$60,$06,$FB,$8C,$DA,$8B,$30,$33,$C0,
                $B9,$02,$72,$51,$9D,$B9,$FF,$00,$8B,$D8,$50,$8B,$FC,$EA);

                {alternative method with memory block resizing code}
                ThirdPartAltM: array [0..224] of byte = ( {x2comld4.asm}
                $E8,$00,$00,$5E,$81,$EE,$00,$01,$8B,$DE,$8C,$C8,$8E,$D8,$8E,
                $C0,$05,$10,$00,$FF,$06,$18,$01,$BE,$DE,$01,$8B,$16,$1E,$01,
                $03,$D0,$89,$50,$04,$8B,$16,$20,$01,$89,$50,$06,$8B,$16,$26,
                $01,$03,$D0,$89,$50,$02,$8B,$16,$24,$01,$89,$10,$8B,$0E,$16,
                $01,$E3,$1C,$8B,$3E,$28,$01,$26,$C5,$B5,$10,$01,$83,$C7,$04,
                $8C,$DA,$03,$D0,$2E,$03,$16,$18,$01,$8E,$DA,$01,$04,$49,$75,
                $E8,$FC,$8E,$C0,$8E,$D8,$33,$FF,$2E,$8B,$36,$18,$01,$B1,$04,
                $D3,$E6,$8B,$CB,$2B,$CE,$D1,$E9,$F3,$A5,$8C,$C8,$8E,$D8,$8E,
                $C0,$53,$8B,$1E,$1C,$01,$B4,$4A,$CD,$21,$73,$3D,$3B,$1E,$1A,
                $01,$72,$06,$B4,$4A,$CD,$21,$73,$31,$5B,$8B,$D3,$81,$C2,$9C,
                $01,$B4,$09,$CD,$21,$B4,$4C,$CD,$21,$50,$72,$6F,$67,$72,$61,
                $6D,$20,$74,$6F,$6F,$20,$62,$69,$67,$20,$74,$6F,$20,$66,$69,
                $74,$20,$69,$6E,$20,$6D,$65,$6D,$6F,$72,$79,$2E,$24,$5B,$BE,
                $DE,$01,$FA,$8E,$50,$04,$8B,$60,$06,$FB,$8C,$DA,$8B,$30,$33,
                $C0,$B9,$02,$72,$51,$9D,$B9,$FF,$00,$8B,$D8,$50,$8B,$FC,$EA);

                BufferSize = 32000;
                Alternative: Boolean = False;
                AddResizeCode: Boolean = True;
                Quiet: Boolean = False;
                Verbose: Boolean = False;
                Overwrite: Boolean = False;

const           SourceName: String = '';
                DestName: String ='';

procedure       About;
begin           writeln(#13+
                'X2COM  version ' + Version + ' (DOS' +
                {$IfNDef Win32}
                  {$IfNDef __TMT__} '16'
                  {$Else   __TMT__} '32'
                  {$EndIF  __TMT__}
                {$Else   Win32} '32'
                {$Endif  Win32}
                + ') built [' +
                Date + '].'#13#10+
                'EXE to COM conversion tool. Written by Y [27-03-99].'#13#10 +
                'Copyright (c) 1999 CROWELL, Inc. All Rights Reserved.'#13#10);
end;            {About}

procedure       Help;
begin           writeln(
                'Syntax: X2COM <executable[.exe]> [options]'#13#10#13#10 +
                'Options:'#13#10'/A'#9'- use alternative conversion method ' +
                '(exe header kept intact)'#13#10 +
                '/N'#9'- don''t add memory block resizing code ' +
                '(for clean non-DOS system)'#13#10,
                '/O'#9'- overwrite output file if it exists'#13#10 +
                '/Q'#9'- quiet mode (suppress almost all messages)'#13#10 +
                '/V'#9'- verbose mode (display all possible information)');
                Halt(255);
end;            {Help}

procedure       IOchck;
begin           if IOresult<>0 then end; {-:
end;            {IOchck}

procedure       Error(Code: Integer; Message: String);
begin           if (not Verbose)
                then writeln('failed!'#13#10)
                else writeln;
                write('***Error (00', Code, '): ' + Message + #13#10);
                Halt(Byte(-Code));
end;            {Error}

function        Up(S: String): String;
var             i: integer;
begin           for i := 1 to Length(S) do
                    if S[i] in ['a'..'z']
                    then inc(S[i], byte('A') - byte('a'));
                Up := S;
end;            {Up}

function        CutString(var S: String): String;
var             Temp: String;
begin           Temp := '';
                while ((S[1] = ' ') and (S <> '')) do
                  Delete(S, 1, 1);
                while ((S[1] <> ' ') and (S <> '')) do
                begin Temp := Temp + S[1];
                      Delete(S, 1, 1);
                end;
                CutString := Temp;
end;            {CutString}

function        GetParams: Boolean;
var             ParamString: String;
                Temp: Boolean;
                i: integer;
begin           Temp := False;

                {$IfDef __TMT__}
                ParamString := Args;
                {$Else  __TMT__}
                  {$IfNDef Win32}
                ParamString := String(Ptr(PrefixSeg, $80)^);
                  {$Else   Win32}
                ParamString := GetCommandLine();
                CutString(ParamString);
                  {$EndIf  Win32}
                {$Endif __TMT__}

                i := Pos(' /A', Up(ParamString));
                if (i <> 0) then
                begin Alternative := True;
                      Delete(ParamString, i, 3);
                end;

                i := Pos(' /N', Up(ParamString));
                if (i <> 0) then
                begin AddResizeCode := False;
                      Delete(ParamString, i, 3);
                end;

                i := Pos(' /O', Up(ParamString));
                if (i <> 0) then
                begin Overwrite := True;
                      Delete(ParamString, i, 3);
                end;

                i := Pos(' /Q', Up(ParamString));
                if (i <> 0) then
                begin Quiet := True;
                      Delete(ParamString, i, 3);
                end;

                i := Pos(' /V', Up(ParamString));
                if (i <> 0) then
                begin Verbose := True;
                      Delete(ParamString, i, 3);
                end;

                SourceName := CutString(ParamString);
                ParamString := CutString(ParamString);
                if (ParamString <> '')
                  then DestName := ParamString;

                if (SourceName <> '') then Temp := True;

                GetParams := Temp;
end;            {GetParams}

procedure       Process(Filename, OutFilename: String; {standard method}
                  AddResizeCode: Boolean);
var             Infile, OutFile: File;
                Buffer: Pointer;
                ExeSize, Temp32: Longint;
                RelocAddress, Temp16, dTemp16: System.Word;
                i, j, Sections: integer;
                Err: Integer;
                DataBlock:
                packed record
                  IP, CS, SS, SP, FixupCount: System.Word;
                end;
                MemDataBlock:
                packed record
                  MinMem, MaxMem: System.Word;
                end;
type            TWLinear = packed array[0..32000] of System.Word;
                DWordRec =
                record
                  Low, High: System.Word;
                end;
begin
                if (Verbose) then
                  writeln('Opening files for standard method...');

                {open input file}
                Assign(InFile, Filename); Reset(InFile, 1);
                if (IOresult <> 0) then
                   Error(1, 'cannot open ' + Filename);

                {open output file}
                Assign(OutFile, OutFilename); Rewrite(OutFile, 1);
                if (IOresult <> 0) then
                begin Close(Infile);
                      Error(2, 'cannot open ' + OutFilename);
                end;

                {get file size}
                ExeSize := FileSize(InFile);
                if (Verbose)
                then writeln('Exe file size: ', ExeSize);

                {read a portion of MZ-header to learn header size}
                GetMem(Buffer, BufferSize);
                BlockRead(InFile, Buffer^, 32, Err);
                if Verbose then
                   writeln('Reading exe-header portion: ', Err, ' bytes...');
                {$IfNDef __TMT__}
                Dec(ExeSize, TWLinear(Buffer^)[4] * 16); {sub para in header}
                {$Else}
                Temp16 := TWLinear(Buffer^)[4]; Temp16 := Temp16 * 16;
                ExeSize -:= Temp16;
                {$Endif}
                RelocAddress := TWLinear(Buffer^)[12];
                with DataBlock do
                begin
                  IP := TWLinear(Buffer^)[10];
                  CS := TWLinear(Buffer^)[11];
                  SS := TWLinear(Buffer^)[07];
                  SP := TWLinear(Buffer^)[08];
                  FixupCount := TWLinear(Buffer^)[03];
                  if (Verbose)
                  then writeln('Total relocations: ', FixupCount);
                end;
                with MemDataBlock do
                begin
                  MinMem := TWLinear(Buffer^)[05];
                  MaxMem := TWLinear(Buffer^)[06];
                end;
                if (Verbose)
                then writeln('Exe image size: ', ExeSize);

                {check file size}
                if (ExeSize > 64000) then
                begin Close(Infile); Close(OutFile);
                      Erase(Outfile); IOchck;
                      Error(3, Filename + ' is too big');
                end;

                {calculate JMP opcode offset}
                i := ExeSize + 13;
                FirstPart.wOffset := i;

                {write the 1st part}
                if (Verbose)
                then writeln('Writing jmp with x2com signature...');
                BlockWrite(OutFile, FirstPart, SizeOf(FirstPart), Err);
                IOchck;

                {write the 2nd part}
                if (Verbose)
                then writeln('Writing source exe-file image...');
                Seek(InFile, TWLinear(Buffer^)[4] * 16); {skip header}
                repeat BlockRead(InFile, Buffer^, BufferSize, Err); IOChck;
                       BlockWrite(Outfile, Buffer^, Err, Err); IOChck;
                until EOF(InFile);

                {write the 3rd party}
                if (Verbose)
                then writeln('Writing standard image loader...');
                if AddResizeCode
                then BlockWrite(Outfile, ThirdPartM,
                       SizeOf(ThirdPartM), Err)
                else BlockWrite(Outfile, ThirdPart,
                       SizeOf(ThirdPart), Err);
                IOchck;

                {write the data blocks}
                if (Verbose)
                then writeln('Writing data blocks...');
                BlockWrite(Outfile, DataBlock, SizeOf(DataBlock), Err);
                IOchck;
                if AddresizeCode then
                begin BlockWrite(Outfile, MemDataBlock,
                        SizeOf(MemDataBlock), Err);
                      IOchck;
                end;

                {write relocations}
                if (Verbose)
                then writeln('Writing relocations...');
                Seek(Infile, RelocAddress); Temp16 := 0;
                for i := 1 to DataBlock.FixupCount do
                begin BlockRead(InFile, Temp32, SizeOf(Temp32), Err);
                      IOchck;
                      Temp32 := DWordRec(Temp32).High * 16 +
                        DWordRec(Temp32).Low;
                      dTemp16 := Temp32 - Temp16;
                      Temp16 := Temp32;
                      BlockWrite(Outfile, dTemp16, SizeOf(dTemp16), Err);
                      IOchck;
                end;

                {clean up}
                Close(InFile); IOChck;
                Close(OutFile); IOChck;
                if (Verbose)
                then writeln('Standard conversion performed successfully.');
end;            {Process}

procedure       ProcessAlt(Filename, OutFilename: String; {alternate method}
                  AddResizeCode: Boolean);
var             Infile, OutFile: File;
                Buffer: pointer;
                InfileSize: longint;
                i, j, Sections: integer;
                Err: integer;
begin
                if (Verbose) then
                  writeln('Opening files for alternative method...');

                {open input file}
                Assign(InFile, Filename); Reset(InFile, 1);
                if (IOresult <> 0) then
                   Error(1, 'cannot open ' + Filename);

                {open output file}
                Assign(OutFile, OutFilename); Rewrite(OutFile, 1);
                if (IOresult <> 0) then
                begin Close(Infile);
                      Error(2, 'cannot open ' + OutFilename);
                end;

                {check input file size}
                InFileSize := FileSize(InFile); IOchck;
                if (Verbose)
                then writeln('Exe file size: ', InFileSize);
                if (InFileSize > 64000) then
                begin Close(Infile); Close(OutFile);
                      Erase(Outfile); IOchck;
                      Error(3, Filename + ' is too big');
                end;

                {calculate JMP opcode offset}
                i := InFileSize + 13;
                FirstPart.wOffset := i;

                {write the 1st part}
                if (Verbose)
                then writeln('Writing jmp with x2com signature...');
                BlockWrite(OutFile, FirstPart, SizeOf(FirstPart), Err);
                IOchck;

                {write the 2nd part}
                if (Verbose)
                then writeln('Writing source exe-file...');
                GetMem(Buffer, BufferSize);
                repeat BlockRead(InFile, Buffer^, BufferSize, Err); IOChck;
                       BlockWrite(Outfile, Buffer^, Err, Err); IOChck;
                until EOF(InFile);

                {write the 3rd part}
                if (Verbose)
                then writeln('Writing alternative image loader...');
                if AddResizeCode
                then BlockWrite(Outfile, ThirdPartAltM,
                       SizeOf(ThirdPartAltM), Err)
                else BlockWrite(Outfile, ThirdPartAlt,
                       SizeOf(ThirdPartAlt), Err);
                IOchck;

                {clean up}
                Close(InFile); IOChck;
                Close(OutFile); IOChck;
                if (Verbose)
                then writeln('Alternative conversion performed successfully.');
end;            {ProcessAlt}

procedure       Run;
var             TempFile: Text;
begin
                {assume extension}
                if (Pos('.', SourceName) = 0) then
                  SourceName := SourceName + '.exe';

                {generate output file name}
                if (DestName = '')
                then DestName := Copy(SourceName, 1, Pos('.', SourceName)-1);
                if (Pos('.', DestName) = 0)
                then DestName := DestName + '.com';

                if (Quiet and Verbose) then
                begin writeln('Warning: quiet and verbose modes cannot ' +
                      'be set simultaneously.'#13#10 +
                      'Program goes on assuming verbose mode.'#13#10);
                      Quiet := False;
                end;

                if (not Quiet) then
                begin write(
                      'Input file:'#9 + SourceName + #13#10 +
                      'Output file: '#9 + DestName + ' (will ');
                      if (not Overwrite) then write('never ');
                      write('be overwritten)'#13#10 +
                      'Method:  '#9);
                      if (Alternative)
                      then write('alternative (with ')
                      else write('standard (with ');
                      if (not AddResizeCode) then write('no ');
                      writeln('memory resizing code)');
                      writeln;
                end;
                if (not Verbose) then write('Trying...');

                if (Verbose) then writeln('Looking for output file...');
                {check if output file exists}
                Assign(TempFile, DestName);
                Reset(TempFile);
                if (IOresult = 0) then
                begin Close(TempFile); IOChck;
                      if (not Overwrite) then
                        Error(4, 'output file exists (use /O to overwrite)');
                end;

                if (not Alternative)
                then Process(SourceName, DestName, AddResizeCode)
                else ProcessAlt(SourceName, DestName, AddResizeCode);

                if (not Verbose) then writeln('done.');
end;            {Run}

begin           About;
                if (not GetParams)
                then Help
                else Run;

end.            {x2com}