
                TITLE EXE to COM convertor loader code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; EXE to COM/BIN/??? convertor. Written by Y [26-07-99].
;; Improved loader with 16-bit relocations.
;; Memory block is resized via DOS fn 4Ah, so DOS 2.0+ is required.
;; Copyright (c) 1999 CROWELL, Inc. All Rights Reserved.
;;
;; Modification history:
;; 04-08-99 by Y: initial implementation
;; 05-08-99 by Y: registers are set up more carefully before last JMP
;; 05-08-99 by Y: added memory block resizing code, removed some lame stuff
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                IDEAL
                MODEL TINY
                JUMPS

Origin          EQU 100h

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                CODESEG
                ORG     Origin

Start:          ;JMP     RealStart
                DB      0E9h
                DW      RealStart - aCMTSignature

aCMTSignature   DB      'x2com v.0.02b'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                ;IDEAL
                ;MODEL SMALL

Entry:          PUSH    DS
                PUSH    AX
                MOV     AX, 2                   ; MOV AX, @DATA
                MOV     DS, AX
                MOV     DX, 0                   ; LEA DX, Message
                MOV     BX, 1
                MOV     AH, 40h
                MOV     CX, MessageSize
                INT     21h
                RETF

                ;DATASEG
                DB 11 dup (?)
Message         DB 'this is a dummy converted MS-DOS exe-file.'
                MessageSize = ($ - Message)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NewIP           EQU word ptr BX+SI              ; BX + SI -> Variables:
NewCS           EQU word ptr BX+SI+2
NewSS           EQU word ptr BX+SI+4
NewSP           EQU word ptr BX+SI+6
FixupCount      EQU word ptr BX+SI+8
wMinMem         EQU word ptr BX+SI+10
wMaxMem         EQU word ptr BX+SI+12
NextFixup       EQU word ptr BX+SI              ; BX + SI -> Fixups:

RealStart:      CALL    PushIP                  ; determine $
                PushIP:
                POP     SI                      ; BX = $
                SUB     SI, Origin
                MOV     BX, SI

                MOV     AX, CS
                MOV     DS, AX
                MOV     ES, AX
                ADD     AX, Origin / 10h        ; add current origin in para

                MOV     SI, Variables - PushIP + Origin
                MOV     DX, [NewSS]
                ADD     DX, AX
                MOV     [NewSS], DX
                MOV     DX, [NewCS]
                ADD     DX, AX
                MOV     [NewCS], DX

AdjustRelocs:   MOV     CX, [FixupCount]
                JCXZ    MoveData
                MOV     SI, Fixups - PushIP + Origin    ; [BX + SI] -> fixups
                LEA     DI, [Entry]

  RelocateLoop: ADD     DI, [NextFixup]
                ADD     SI, 2                   ; adjust NextFixup
                ADD     [DS:DI], AX
                DEC     CX
                JNZ     RelocateLoop

MoveData:       CLD                             ; increment SI/DI
                MOV     ES, AX                  ; AX = seg Start
                MOV     DS, AX
                XOR     DI, DI
                MOV     SI, offset Entry - Origin

                MOV     CX, BX                  ; 3 bytes addition =
                SUB     CX, DI                  ; PushIP - RealStart,
                SHR     CX, 1                   ; so we don't need to INC CX
                REP MOVSW

                MOV     AX, CS                  ; Set up startup registers
                MOV     DS, AX
                MOV     ES, AX

ResizeBlock:    PUSH    BX
                MOV     SI, Variables - PushIP + Origin ; enable variables
                MOV     BX, [wMaxMem]
                MOV     AH, 4Ah
                INT     21h
                JNC     ResizeOk
                MOV     DX, BX
                POP     BX
                PUSH    BX
                CMP     DX, [wMinMem]
                JB      ResizeError
                MOV     BX, DX
                MOV     AH, 4Ah
                INT     21h
                JNC     ResizeOk
ResizeError:    POP     BX
                MOV     DX, BX
                ADD     DX, ErrMessage - PushIP + Origin
                MOV     AH, 9
                INT     21h
                MOV     AH, 4Ch
                INT     21h
ErrMessage      DB      'Program too big to fit in memory.$'
ResizeOk:       POP     BX

                MOV     SI, Variables - PushIP + Origin ; enable variables
                CLI
                MOV     SS, [NewSS]
                MOV     SP, [NewSP]
                STI
                MOV     DX, DS
                MOV     SI, [NewIP]
                XOR     AX, AX
                MOV     CX, 07202h
                PUSH    CX
                POPF
                MOV     CX, 00FFh
                MOV     BX, AX
                PUSH    AX
                MOV     DI, SP

                DB 0EAh                         ; JMP far ptr...

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Variables:      DW 00000h                       ; newIP
                DW 00000h                       ; newCS
                DW 00005h                       ; newSS
                DW 00100h                       ; newSP
                DW 00001h                       ; fixups count
                DW 00000h                       ; wMinMem
                DW 0FFFFh                       ; wMaxMem

Fixups:         DW 00003h                       ; 1st fixup

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                END     Start
