
                TITLE EXE to COM convertor loader code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; EXE to COM/BIN/??? convertor. Written by Y [26-07-99].
;; Memory block is resized via DOS fn 4Ah, so DOS 2.0+ is required.
;; EXE-file-kept-intact version (aka "alternative conversion method").
;; Copyright (c) 1999 CROWELL, Inc. All Rights Reserved.
;;
;; Modification history:
;; 26-07-99 by Y: initial implementation
;; 05-08-99 by Y: registers are set up more carefully before last JMP
;; 05-08-99 by Y: added memory block resizing code
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                IDEAL
                MODEL TINY
                JUMPS

Origin          EQU 100h

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                CODESEG
                ORG     Origin

Start:          ;JMP     RealStart
                DB      0E9h
                DW      RealStart - aCMTSignature

aCMTSignature   DB      'x2com v.0.02b'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                ORG     Origin+10h
wMarkZbikowski  DW      ?               ; Not needed ;)
wBytesLastPage  DW      ?
wPagesInFile    DW      ?
wRelocations    DW      00001h
wParaInHeader   DW      00002h
wMinMem         DW      00000h
wMaxMem         DW      0FFFFh
wSS             DW      00000h
wSP             DW      00000h
wChecksum       DW      00000h
wIP             DW      00000h
wCS             DW      00000h
wRelocsAddress  DW      0001Ch
                DW      00000h
                DW      00003h
                DW      00000h

Entry:          PUSH   DS
                PUSH   AX
                MOV    AX, 0
                MOV    DS, AX
                RETF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

newIP           EQU word ptr BX+SI              ; variables
newCS           EQU word ptr BX+SI+2
newSS           EQU word ptr BX+SI+4
newSP           EQU word ptr BX+SI+6

RealStart:      CALL    PushIP                  ; determine $
                PushIP:
                POP     SI                      ; BX = $
                SUB     SI, Origin
                MOV     BX, SI

                MOV     AX, CS
                MOV     DS, AX
                MOV     ES, AX
                ADD     AX, Origin / 10h
                INC     [wParaInHeader]         ; add a paragraph with a JMP

                MOV     SI, Variables - PushIP + Origin
                MOV     DX, [wSS]
                ADD     DX, AX
                MOV     [newSS], DX
                MOV     DX, [wSP]
                MOV     [newSP], DX
                MOV     DX, [wCS]
                ADD     DX, AX
                MOV     [newCS], DX
                MOV     DX, [wIP]
                MOV     [newIP], DX

AdjustRelocs:   MOV     CX, [wRelocations]
                JCXZ    MoveData
                MOV     DI, [wRelocsAddress]

  RelocateLoop: LDS     SI, [dword ptr ES:wMarkZbikowski+DI]
                ADD     DI, 4
                MOV     DX, DS
                ADD     DX, AX
                ADD     DX, [CS:wParaInHeader]  ; DS is altered, so use CS
                MOV     DS, DX
                ADD     [DS:SI], AX
                DEC     CX
                JNZ     RelocateLoop

MoveData:       CLD                             ; increment SI/DI
                MOV     ES, AX                  ; AX = seg Start
                MOV     DS, AX
                XOR     DI, DI
                MOV     SI, [CS:wParaInHeader]
                MOV     CL, 4
                SHL     SI, CL                  ; in bytes

                MOV     CX, BX                  ; 3 bytes addition =
                SUB     CX, SI                  ; PushIP - RealStart,
                SHR     CX, 1                   ; so we don't need to INC CX
                REP MOVSW

                MOV     AX, CS                  ; set CS=DS=ES
                MOV     DS, AX
                MOV     ES, AX

ResizeBlock:    PUSH    BX
                MOV     BX, [wMaxMem]
                MOV     AH, 4Ah
                INT     21h
                JNC     ResizeOk
                CMP     BX, [wMinMem]
                JB      ResizeError
                MOV     AH, 4Ah
                INT     21h
                JNC     ResizeOk
ResizeError:    POP     BX
                MOV     DX, BX
                ADD     DX, ErrMessage - PushIP + Origin
                MOV     AH, 9
                INT     21h
                MOV     AH, 4Ch
                INT     21h
ErrMessage      DB      'Program too big to fit in memory.$'
ResizeOk:       POP     BX

                MOV     SI, Variables - PushIP + Origin ; enable variables
                CLI
                MOV     SS, [newSS]
                MOV     SP, [newSP]
                STI
                MOV     DX, DS
                MOV     SI, [NewIP]
                XOR     AX, AX
                MOV     CX, 07202h
                PUSH    CX
                POPF
                MOV     CX, 00FFh
                MOV     BX, AX
                PUSH    AX
                MOV     DI, SP

                DB 0EAh                         ; JMP far ptr...

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Variables:
;newIP           DW ?
;newCS           DW ?
;newSS           DW ?
;newSP           DW ?

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                END     Start
